(ns wanijo.framework.neo4j
  (:require [neo4j-clj.core :as db]
            [wanijo.framework.devmode :as devmode])
  (:import (java.util UUID)))

(def conn
  (delay (db/connect
          "bolt://localhost:7687"
          "neo4j"
          "b")))

(defmacro defquery [& args] `(db/defquery ~@args))

(defn uuid []
  (str (UUID/randomUUID)))

(defn butiful-query [qry]
  (->> qry
       str
       clojure.string/trim-newline
       clojure.string/split-lines
       (map clojure.string/trim)
       (filter #(> (count %) 0))
       (clojure.string/join \newline)))

(defn exec-query [qry params]
  (with-open [session (db/get-session @conn)]
    (devmode/send-to-bar
     (str (butiful-query qry)
          "<br>---Params---<br>"
          params))
    (qry session params)))
